/*
*	Hautelman Ernest Claudiu 332 CB
*	5x8 Matrix Memory Game
*	Proiect PM 2015	
*/
#include <avr/io.h>

#define F_CPU 16000000

#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
//randuri si coloane
unsigned char randul[8] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7};
unsigned char coloana[5] = {PD0, PD1, PD2, PD3, PD4};
//butoane pentru control
unsigned char button[5] = {PC0, PC1, PC2, PC3, PC4};
unsigned char up = PC0;
unsigned char left = PC1;
unsigned char select = PC4;
unsigned char down = PC2;
unsigned char right = PC3;

//Se memoreaza miscarile jucatorului
int move_x[9] = {0,0,0,0,0,0,0,0,0};
int move_y[9] = {0,0,0,0,0,0,0,0,0};
int crt_move = 0;

/*
*O
*K
*/
void draw_ok(){
	int r[14] = {0,1,1,2,2,3,4,4,5,5,6,6,7,7};
	int c[14] = {2,1,3,1,3,2,1,3,1,2,1,2,1,3};
	int i, j;
	PORTA = 0;
	PORTD = 0;
	for(i = 0; i < 80; i++){
		for(j = 0; j < 14; j++){
			PORTA |= (1 << randul[r[j]]);
			PORTD |= (1 << coloana [c[j]]);
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	

}

//1
void draw_one(){
	int r[12] = {0,0,1,1,2,2,3,3,4,5,6,7};
	int c[12] = {3,4,2,4,1,4,0,4,4,4,4,4};
	int i, j;
	PORTA = 0;
	PORTD = 0;
	for(i = 0; i < 80; i++){
		for(j = 0; j < 12; j++){
			PORTA |= (1 << randul[r[j]]);
			PORTD |= (1 << coloana [c[j]]);
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}
//2
void draw_two(){
	int r[13] = {2,1,0,1,2,3,4,5,6,6,6,6,6};
	int c[13] = {0,1,2,3,4,3,2,1,0,1,2,3,4};
	int i, j;
		PORTA = 0;
	PORTD = 0;
	for(i = 0; i < 80; i++){
		for(j = 0; j < 13; j++){
			PORTA |= (1 << randul[r[j]]);
			PORTD |= (1 << coloana [c[j]]);
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}
//3
void draw_three(){
	int r[14] = {1,1,1,1,1,2,3,4,5,6,7,7,7,7};
	int c[14] = {0,1,2,3,4,3,2,3,4,4,3,2,1,0};
	int i, j;
		PORTA = 0;
	PORTD = 0;
	for(i = 0; i < 80; i++){
		for(j = 0; j < 14; j++){
			PORTA |= (1 << randul[r[j]]);
			PORTD |= (1 << coloana [c[j]]);
		_delay_ms(1);
			PORTA = 0;
			PORTD = 0;	
		}
	}	
}
//4
void draw_four(){
	int r[12] = {0,1,2,3,4,4,4,4,4,3,5,6};
	int c[12] = {3,2,1,0,0,1,2,3,4,3,3,3};
	int i, j;
	PORTA = 0;
	PORTD = 0;
	for(i = 0; i < 80; i++){
		for(j = 0; j < 12; j++){
			PORTA |= (1 << randul[r[j]]);
			PORTD |= (1 << coloana [c[j]]);
				_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}
//5
void draw_five(){
	int r[10] = {1,1,1,2,3,3,4,5,6,6};
	int c[10] = {1,2,3,1,1,2,3,3,2,1};
	int i, j;
		PORTA = 0;
	PORTD = 0;
	for(i = 0; i < 80; i++){
		for(j = 0; j < 10; j++){
			PORTA |= (1 << randul[r[j]]);
			PORTD |= (1 << coloana [c[j]]);
		_delay_ms(1);
			PORTA = 0;
			PORTD = 0;	
		}
	}	
}
//6
void draw_six(){
	int r[11] = {1,2,3,4,5,6,6,5,4,3,3};
	int c[11] = {2,1,1,1,1,2,3,4,4,3,2};
	int i, j;
	
	for(i = 0; i < 80; i++){
		for(j = 0; j < 11; j++){
			PORTA |= 1 << randul[r[j]];
			PORTD |= 1 << coloana [c[j]];
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}
//7
void draw_seven(){
	int r[8] = {2,2,2,2,3,4,5,6};
	int c[8] = {1,2,3,4,4,3,2,1};
	int i, j;
	
	for(i = 0; i < 80; i++){
		for(j = 0; j < 8; j++){
			PORTA |= 1 << randul[r[j]];
			PORTD |= 1 << coloana [c[j]];
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}
//8
void draw_eight(){
	int r[13] = {0,1,1,2,2,3,4,4,5,5,6,6,7};
	int c[13] = {2,1,3,1,3,2,1,3,1,3,1,3,2};
	int i, j;
	
	for(i = 0; i < 80; i++){
		for(j = 0; j < 13; j++){
			PORTA |= 1 << randul[r[j]];
			PORTD |= 1 << coloana [c[j]];
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}
//9
void draw_nine(){
	int r[11] = {1,2,2,3,3,4,4,5,6,7,6};
	int c[11] = {2,1,3,1,3,2,3,3,3,2,1};
	int i, j;
	
	for(i = 0; i < 80; i++){
		for(j = 0; j < 11; j++){
			PORTA |= 1 << randul[r[j]];
			PORTD |= 1 << coloana [c[j]];
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}
/*
*	0	0
*	  '
*	.""".
*/
void draw_sad_face(){
	int r[8] = {1,1,3,7,6,6,6,7};
	int c[8] = {1,3,2,0,1,2,3,4};
	int i, j;
	
	for(i = 0; i < 80; i++){
		for(j = 0; j < 8; j++){
			PORTA |= 1 << randul[r[j]];
			PORTD |= 1 << coloana [c[j]];
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}
/*
*	N
*	O
*/
void draw_no(){
	int r[15] = {0,0,1,1,1,2,2,3,3,4,5,5,6,6,7};
	int c[15] = {1,3,1,2,3,1,3,1,3,2,1,3,1,3,2};
	int i, j;
	
	for(i = 0; i < 80; i++){
		for(j = 0; j < 15; j++){
			PORTA |= 1 << randul[r[j]];
			PORTD |= 1 << coloana [c[j]];
			_delay_ms(1);
			PORTA = 0;
			PORTD = 0;
		}
	}	
}

void display_level(int level){
	if(level == 1){
		draw_one();
		return;
	}
	
	if(level == 2){
		draw_two();
		return;
	}
	
	if(level == 3){
		draw_three();
		return;
	}
	
	if(level == 4){
		draw_four();
		return;
	}
	
	if(level == 5){
		draw_five();
		return;
	}
	
	if(level == 6){
		draw_six();
		return;
	}
	
	if(level == 7){
		draw_seven();
		return;
	}
	
	if(level == 8){
		draw_eight();
		return;
	}
		
	if(level == 9){
		draw_nine();
		return;
	}
}

void generate_move(int level){
	int i;
	crt_move = 0;
	
	for(i = 0; i < level; i++){
		move_x[i] = rand() % 8;
		move_y[i] = rand() % 5;
		
		PORTA = (1 << randul[move_x[i]]);
		PORTD = (1 << coloana[move_y[i]]);
		
		_delay_ms(1400-100*level);
		PORTA = 0;
		PORTD = 0;
	}
}


int main(){

	int posx = 0, posy = 0;
	int level = 0;
	
	DDRA = 255;
	DDRD = 255;
	
	DDRC = 0;
	PORTC = 255;
	
	while(1){
		//Aprinde led-ul de pe pozitia curenta;
		PORTA = (1 << randul[posx]);
		PORTD = (1 << coloana[posy]);
		
		//Verifica prin polling daca s-a apasat vreun buton si in
		//caz afirmativ se iau masurile necesare: deplasare, selectare,
		//resetare;
		if((PINC & (1 << up)) == 0){
			posy = (posy + 1) % 5;
			_delay_ms(200);
		}
		
		if((PINC & (1 << down)) == 0){
			posy = ((posy - 1) >= 0) ? posy - 1 : 4;
			_delay_ms(200);
		}
		
		if((PINC & (1 << left)) == 0){
			posx = ((posx - 1) >= 0) ? posx - 1 : 7;
			_delay_ms(200);
		}
		
		if((PINC & (1 << right)) == 0){
			posx = (posx + 1) % 8;
			_delay_ms(200);
		}
		
		if((PINC & (1 << select)) == 0){
			if (level == 0){
					level = 1;
					display_level(level);
					generate_move(level);
			}else if(posx == move_x[crt_move] && posy == move_y[crt_move]){
				draw_ok();
				crt_move++;
				posx = 0;
				posy = 0;
				if(crt_move == level){
					level++;
					display_level(level);
					generate_move(level);
				}
			}else{
				draw_sad_face();
				draw_no();
				level = 0;
				posx = 0;
				posy = 0;
			}
		}
		
		PORTA = 0;
		PORTD = 0;
	}
	
	
	return 0;
}